/***********************************************************************
 Demo for T6x with T/SDAS-TLC AD/DA board test utility.
 DAC output and ADC Acquisition with pretriggering. No previous reset.
 Copyright (C) MicroLAB(tm) Systems Ltd, 1994-1998

*************************************************************************/



#include <malloc.h>
#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include <mlu.h>
#include <ips_ut.h>

#include <t6x_h.c>
#include "ht6_comm.i"


long       scan_len;   // epoch length in samples
long       kbd_cmnd,cmnd;       // amplitude

long	i,chan=3;
int	tmp,ex_status,adc_scan_flag=0;
char	s[80],ch;
int	dat_type=4; // def for LONG type (number of bytes per word)

MLU_TBDD TB;  // time bell descriptor


#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");



struct MCD_DD  *MCD;     // MCD pointer

long   *D;               // master data buffer array
long       MADC_SADDR, MDAC_SADDR;
long	max_scan_len=0;

long	 fq_code=1, gain=1;
unsigned long is=0,ra,rb;

struct	MCD_STLC_DD
	{
	  unsigned long is;	// input selector (0-main, 1-aux)
	  unsigned long ra,rb;  // internal TLC clock counters that define sampling freq
	  unsigned long gain;
	}
		*MCD_STLC ;




inp_param()
{

  enter_sf:
      printf("Speech bandwidth (Fb) and sampling (Fs) frequencies selection: \n");
      printf("     0: 6k/16k \n");
      printf("     1: 3k/8k\n");

      printf("enter Fs code #           : ");
      fq_code=getlong(0L,4L,fq_code,CR_ENABLE,ESC_MASK,&ex_status);

      if(ex_status==ESC_MASK)
       {aborted:
	  printf(" <aborted>\n");
	  return(1);
       }

      switch(fq_code)
       {
         case 0: ra=8;rb=18;	break;
         case 1: ra=16;rb=18;	break;
	 default:
		  break;

       }

      printf("input signal scale: \n");
      printf("     0: +-6v \n");
      printf("     1: +-3v\n");
      printf("     2: +-1.5v\n");

      printf("enter input scale code    : ");
      gain=getlong(0L,2L,gain,CR_ENABLE,ESC_MASK,&ex_status);
      if(ex_status==ESC_MASK) goto aborted;



      printf("input select(0-main/1-aux): ");
      is=getlong(0L,1L,is,CR_ENABLE,ESC_MASK,&ex_status);

      if(ex_status==ESC_MASK) goto aborted;

	printf("\n");
      return(0);	

}





/*****************************************************************************
// fill on-board SRAM with zero or sine waves with F0 and 2xF0 frequencies
*****************************************************************************/

#define FILL_SINE   1
#define FILL_ZERO   0

 int __fill_dac_sram(int fill_mode)
  { long count, q, n, n1, j, w_len;

      CLEAR_CURRENT_LINE;
      printf("filling SRAM ...\r");
       	
	    j=MDAC_SADDR;
	    count=scan_len;
	    n=0L;

	    do
	      {
                T6X_set_smp_ptr(j,T6X_SRAM_AREA,&D);
		w_len=(T6X_SMP_LEN-j%T6X_SMP_LEN)/dat_type;
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++)
		  {
		    if(fill_mode==FILL_SINE)
                           *D++ = (long) ((double) (2000.0 * sin(1000.0*M_PI*((double)(n1+n))/((double) scan_len))));
		     else
			  *D++ = 0;
		  }

                if(T6X_sb_err_data())
	           {
		     CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;	
		j+=(q*dat_type);
		n+=q;
	      }
	     while (count>0);

     CLEAR_CURRENT_LINE;
     return(0);
  }



 int __read_sb_data(long sb_addr, long len, void *pc_ptr)
  {
    long j, count,n1,q, w_len;
    long *LPTR;


            LPTR=(long *)pc_ptr;
	    j=sb_addr;
	    count=len;

	    do
	      {

                T6X_set_smp_ptr(j,T6X_SRAM_AREA,&D);
		w_len=(T6X_SMP_LEN-j%T6X_SMP_LEN)/dat_type;
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++, *LPTR++= *D++);

                if(T6X_sb_err_data())
	           {
		      CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;	
		j+=(q*dat_type);
	      }
	     while (count>0);
       return(0);

  }


 int __write_sb_data(long sb_addr, long len, void *pc_ptr)
  {
    long j, count,n1,q, w_len;
    long *LPTR;


            LPTR=(long *)pc_ptr;
	    j=sb_addr;
	    count=len;

	    do
	      {
                T6X_set_smp_ptr(j,T6X_SRAM_AREA,&D);
		w_len=(T6X_SMP_LEN-j%T6X_SMP_LEN)/dat_type;
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++, *D++=*LPTR++ );

                if(T6X_sb_err_data())
	           {
		      CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;	
		j+=(q*dat_type);
	      }
	     while (count>0);
       return(0);

  }






#define TMP_BUF_LEN	0x8000L


 int __move_adc_to_dac(long buf_len)
  {
    long count, j, q, jd;
    long *TMP;



      CLEAR_CURRENT_LINE;
      printf("moving SRAM data ...\r");
       	

    if((TMP=(long *) halloc(TMP_BUF_LEN*dat_type,1))==NULL)

       { printf("error: out of memory\n\n");
	 return(1);
       }

                      /* copy ADC data to DAC buffer */

	    j=MADC_SADDR;
	    jd=MDAC_SADDR;
	    count=buf_len;

	    do
	      {
                if(count>=TMP_BUF_LEN) q=TMP_BUF_LEN;
		    else	q=count;
		if(   __read_sb_data(j,q,TMP)!=0
		   || __write_sb_data(jd,q,TMP)!=0
		  )
           	   {
                     hfree(TMP);return(1);
	           }
		count-=q;	
		j+=(q*dat_type);
		jd+=(q*dat_type);
	      }
	     while (count>0);


    CLEAR_CURRENT_LINE;
    hfree(TMP);
    return(0);
  }



int do_cmd(int adc_scan_enable)
 {
  T6X_set_smp_ptr(MCD_SADDR,T6X_SRAM_AREA,&MCD);

  MCD->cmnd		= cmnd;
  MCD->fq		= 0;
  MCD->epoch_len	= scan_len;
  MCD->status		= MSTAT_ATTN;
  MCD->chan		= 0;

  MCD_STLC->is		= is;
  MCD_STLC->ra		= ra;
  MCD_STLC->rb		= rb;
  MCD_STLC->gain	= gain;


  adc_scan_flag=0;

  T6X_SET_HM_RQ;  // set MASTER ATTN via interrupt

  printf(" T6x operation in progress. Press <SPACE> to terminate or <ESC> to abort...\r");
  do                      // wait for the ESC pressed or data ready
   {

     if(key_pressed())
       { switch (read_char())
	  { case KEY_ESC:
 	      exe_aborted:
	         CLEAR_CURRENT_LINE;
	         printf("<execution aborted, T6x reset>\n");
	      m_restart:
	         T6X_SET_MRESET;
		 T6X_CLR_SB_ERR;
	         return(1);

            case 0x20:  // issue ADC SCAN synch
                 if (adc_scan_enable)
		  {
                    if (!adc_scan_flag)
	    	      { CLEAR_CURRENT_LINE;
		        printf("\rADC scanning...\r");
                        adc_scan_flag=MLU_ON;
		        MCD->status=MSTAT_GO;
		      }
		  }
		  else
		  {
	            T6X_SET_MRESET;
		    T6X_CLR_SB_ERR;
		    T6X_SET_MGO;
		    return(0);
		  }
		 break;

            default:
		 break;
	
	  }
       }
   }
    while(MCD->status!=MSTAT_RDY);

   if (MCD->err!=MLU_OK)
     { CLEAR_CURRENT_LINE;
       printf("error: %ld\n", MCD->err);
       return (1);
     }
   return(0);
 }



int do_adc_to_dac_cmnd()
 {
  T6X_set_smp_ptr(MCD_SADDR,T6X_SRAM_AREA,&MCD);

  MCD->cmnd		= cmnd;
  MCD->fq   		= 0;
  MCD->epoch_len	= 0x10;
  MCD->status		= MSTAT_ATTN;
  MCD->chan		= 0;

  MCD_STLC->is		= is;
  MCD_STLC->ra		= ra;
  MCD_STLC->rb		= rb;
  MCD_STLC->gain	= gain;

  adc_scan_flag=0;
  T6X_SET_HM_RQ;  // set MASTER ATTN via interrupt

  printf(" ADC->DAC is in progress. Press <SPACE> to terminate...\r");

  do                      // wait for the ESC pressed or data ready
   {

     if(key_pressed())
       { switch (read_char())
	  { case KEY_ESC:
 	      exe_aborted:
	         CLEAR_CURRENT_LINE;
	         printf("<execution aborted, T6x reset>\n");
	      m_restart:
	            T6X_SET_MRESET;
		    T6X_CLR_SB_ERR;
                    return(1);

            case 0x20:  // issue ADC SCAN synch
                 if (!adc_scan_flag)
		   { CLEAR_CURRENT_LINE;
		     printf("\rADC->DAC operation is aborted...\r");
                     adc_scan_flag=MLU_ON;
		     MCD->status=MSTAT_ABORT;
		   }
            default:
		 break;
	
	  }
       }
   }
    while(MCD->status!=MSTAT_RDY);
 
   if (MCD->err!=MLU_OK)
     { CLEAR_CURRENT_LINE;
       printf("error: %ld\n", MCD->err);
       return (1);
     }
   return(0);
 }







main()
{ int r;
  char err_mess[100], dev_name[30];
  unsigned dev_id;

   printf("\nDemo for TORNADO-6x and T/SDAS-SCOM1 Speech/Fax/Modem SIOX-module. v.1.0\n");
   printf("(C) MicroLAB Systems Ltd, 1998\n\n");


   if((r=T6X_open(0x350))!=T6X_OK)
     {  error:
          T6X_last_err_message(err_mess);
	  printf("error: %s\n", err_mess);
	  goto exit;
     }

  T6X_dev_id_data(&dev_id);
  T6X_dev_name(dev_name);

  printf("%s DSP System, s/n: #%x\n",dev_name,(dev_id & 0xff));

   T6X_set_smp_ptr(MCD_SADDR,T6X_SRAM_AREA,&MCD);
   T6X_CLR_SB_ERR;
   T6X_SET_SB_CCL_W32;

   T6X_SET_MRESET;       // init T6x and validate the response code

      MCD->m_id=0xffffffff;
      MCD->prg_id=0xffffffff;
      MCD->status=0xffffffff;
      MCD->err=0xffffffff;
      MCD->cmnd=0xffffffff;
      MCD->adc_data_saddr=0;
      MCD->dac_data_saddr=0;

   MLU_set_bell(1,&TB);  // set time control =1s
   T6X_SET_MGO;

   while (MCD->status!=MSTAT_RDY) // wait for DSP will init or timeout
     {
       if(MLU_check_bell(&TB)<0)
	   { printf("error: no reply from TORNADO-6x\n\n");
	     goto exit;
	   }
       if(T6X_sb_err_data())
	   { printf("error: SB error\n\n");
	     goto exit;
	   }
     }

   if(   MCD->m_id!=T6X_M_ID    // validate MCD returned
      || MCD->prg_id!=T6X_PRG_ID
      || MCD->status!=MSTAT_RDY
      || MCD->cmnd!=0
      || MCD->err!=0
      || MCD->adc_data_saddr==0
      || MCD->dac_data_saddr==0
      || MCD->adc_data_saddr==MCD->dac_data_saddr
      || MCD->epoch_len==0
      || MCD->epoch_len>=(T62_SRAM_EADDR/dat_type)
      || MCD->adc_data_saddr>(T62_SRAM_EADDR-(MCD->epoch_len*dat_type)+1L)
      || MCD->dac_data_saddr>(T62_SRAM_EADDR-(MCD->epoch_len*dat_type)+1L)
     )
       { printf("error: invalid T6x initialization data\n");
	 goto exit;
       }

	// -- read communication params fm TORNADO
	//    and configure local environment
   MADC_SADDR = MCD->adc_data_saddr;
   MDAC_SADDR = MCD->dac_data_saddr;
   max_scan_len = scan_len = MCD->epoch_len;
   MCD_STLC = (struct MCD_STLC_DD*) (& ((char*)&(MCD->chan))[dat_type]);

   __fill_dac_sram(FILL_ZERO);	// clear transmit buffer

while(1)
 {
   printf("\n commands : \n");
   printf("      0 : Output sine wave via DAC\n");
   printf("      1 : Record data in on-board SRAM\n");
   printf("      2 : Cyclic Playback data from on-board SRAM\n");
   printf("      3 : Continuous pass-through (ADC->DAC)\n");
   printf("    Esc : exit to DOS\n\n");

   printf("enter command: ");

kbd_loop:
   switch(read_char())
     {
        case '0':
                CLEAR_CURRENT_LINE;
		printf("Output sine wave via DAC >>>>\n");

		cmnd = MCMND_DAS_DAC_SCAN;
                if(inp_param()!=0) goto exit;
		scan_len=max_scan_len;


		if (    __fill_dac_sram(FILL_SINE)!=0
                     || do_cmd(MLU_OFF)!=0
		     || __fill_dac_sram(FILL_ZERO)!=0
                   ) goto exit;
		break;


	case '1':

                CLEAR_CURRENT_LINE;
		printf("Record data in on-board SRAM >>>>\n");
		cmnd = MCMND_DAS_DAC_SCAN;

                if(inp_param()!=0) goto exit;
		scan_len=max_scan_len;

		if (    __fill_dac_sram(FILL_ZERO)!=0
                     || do_cmd(MLU_ON)!=0
		     || __move_adc_to_dac(scan_len)!=0
                   ) goto exit;
		break;


	case '2':
                CLEAR_CURRENT_LINE;
		printf("Play data from on-board SRAM >>>>\n");

		cmnd = MCMND_DAS_DAC_SCAN;
                if(inp_param()!=0) goto exit;
		scan_len=max_scan_len;

		if ( do_cmd(MLU_OFF)!=0
                   ) goto exit;
		break;


	case '3':
                CLEAR_CURRENT_LINE;
		printf("Continuous Pass-through data (ADC->DAC) >>>>\n");
		cmnd = MCMND_ADC_TO_DAC;
                if(inp_param()!=0) goto exit;

		if (    __fill_dac_sram(FILL_ZERO)!=0
                     || do_adc_to_dac_cmnd()!=0
                   ) goto exit;
                break;


        case KEY_ESC:
	  printf(" <aborted>\n");
	  goto exit;

	default:
		beep_err();
		goto kbd_loop;
     }

 }
exit:
  printf("\n");
}

