/*
	T/SDAS-TLC (TLC3204x) demo/test utility.

*/

#include	<math.h>
#include	<string.h>


#include	"c30_def.h"


#define DN_LEN_MAX 14


struct	MCD_DD
	{ int	m_id,
		prg_id,
                status,
                err,
		cmnd;
	  int	fq;
	  int   epoch_len,
                adc_data_ptr,
                dac_data_ptr,
		chan ,

		is,
		ra,
		rb,
		gain;

	  long  dn[DN_LEN_MAX+2]; /* string array of dialing number */
	} ;

struct	MCD_DD *MCD	= (struct MCD_DD *)0x40;



#define	T31_ID			0x101
#define	PRG_ID			0x100

#define	MSTAT_RDY		0 /* Master status values */
#define	MSTAT_BUSY		1
#define	MSTAT_ATTN		2
#define	MSTAT_GO		3
#define	MSTAT_ABORT		4

#define	MERR_OK			0 /* Master returned error codes */
#define	MERR_INV_CMND		1 /*     ; invalid command */
#define	MERR_INV_ATTN		2
#define	MERR_HOOK		3


#define	MCMND_NOP		0
#define	MCMND_ABORT		1

#define	MCMND_DAS_SCAN		0x100
#define	MCMND_DAS_DAC_SCAN	0x101
#define	MCMND_DAC_SING_LOAD	0x102
#define	MCMND_ADC_TO_DAC	0x103
#define MCMND_OUT_RING		0x104L   /* Output ring SLIC */
#define MCMND_OFF_HOOK		0x105L   /* make Off Hook DAA */


#define	ML_OFF			0
#define	ML_ON			1

#define	MDATA_BUF_LEN		0x3c00L /* maximum data array length */


extern  int adc_data_start;
extern	int dac_data_start;
int	*ADC,	*DAC;		/* ptrs to the ADC/DAC data */

int	host_rq_flag=0;




#include	"t3x_daa.i"

void c_int30()
	{ host_rq_flag=1;
   }

cpu_init()
 {
	   *STB0_C = 0xf0600;
	   *STB1_C = 0xf0600;

        INT_EDGE;
	CACHE_ENABLE;
 }





int	cmnd_decoder()			/* command decoder	*/
 {
	if(MCD->status!=MSTAT_ATTN) return(MERR_INV_ATTN);

	MCD->status=MSTAT_BUSY;

	switch(MCD->cmnd)
	 {
	   case MCMND_NOP:		/* common cmnds */
	   case MCMND_ABORT:
		 return(MERR_OK);

                                        /* application specific commands */
	   case MCMND_DAS_DAC_SCAN:
	   	 return( das_dac_scan() );

	   case MCMND_OFF_HOOK:
		 return( dial_playback() );
	   default:			/* all unknown commands cause error */
		 return( MERR_INV_CMND );
	 }

 }






void main()
{
	cpu_init();

	ADC	=   (int *) &adc_data_start ;
	DAC	=   (int *) &dac_data_start ;

	MCD->m_id		= T31_ID;
	MCD->prg_id		= PRG_ID;
	MCD->cmnd		= 0;
	MCD->fq			= 0;
	MCD->epoch_len		= 0;
	MCD->err		= MERR_OK;
	MCD->adc_data_ptr	= (int) ADC;
	MCD->dac_data_ptr	= (int) DAC;
	MCD->status		= MSTAT_RDY;
	MCD->is			= 0;
	MCD->gain		= 0;

      system_init();			/* perform init of system params */


	INT_ENABLE;

	while(1)			/* continuous loop	*/
	 {
	   host_rq_flag=0;		/* poll for the HOST RQ */

	   EXT_IRQ_CLEAR(3);
	   EXT_INT_ENABLE(3);

           while(host_rq_flag==0) ;

	   EXT_INT_DISABLE(3);		/* disable HOST RQ	*/

	   MCD->err = cmnd_decoder();	/* call exec & return error code */
           MCD->status = MSTAT_RDY;	/* clear status flag */

	 }


}