/***********************************************************************
 Demo for T3x with T/SDAS-SLIC AD/DA board test utility.
 DAC output and ADC Acquisition with pretriggering. No previous reset.
 Copyright (C) MicroLAB(tm) Systems Ltd, 1994

*************************************************************************/



#include <malloc.h>
#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include <mlu.h>
#include <ips_ut.h>
#include "host_t3x.i"

#define  SCAN_LEN_DEFAULT	0x3c00L

long   scan_len,   // epoch length in samples
       kbd_cmnd,cmnd;       // amplitude

long	i,chan=3;
int	tmp,ex_status,adc_scan_flag=0, fq_code=1, gain=1;
char	s[80],ch;
int	dat_type=4; // def for LONG type (number of bytes per word)

MLU_TBDD TB;  // time bell descriptor


#define CLEAR_CURRENT_LINE  printf("\r%78s\r"," ");



struct MCD_DD  *MCD;     // MCD pointer

long   *D,               // master data buffer array
       MADC_SADDR,
       MDAC_SADDR;

long is=0,ra,rb;

struct	MCD_STLC_DD
	{
	  long	is;	// input selector (0-main, 1-aux)
	  long  ra,rb;  // internal TLC clock counters that define sampling freq
	  long  gain;
	  long  off_hook;
	}
		*MCD_STLC ;



inp_param()
{
	ra=16L;rb=18L;
	gain = 2;
	is = 0;
      return(0);

}




/*****************************************************************************
// fill on-board SRAM with zero or sine waves with F0 and 2xF0 frequencies
*****************************************************************************/

#define FILL_SINE   1
#define FILL_ZERO   0

 int __fill_dac_sram(int fill_mode)
  {
    long count, q, n, n1, j, w_len;
		unsigned pmap_old;



	pmap_old= READ_MAP();

      CLEAR_CURRENT_LINE;
      printf("filling SRAM ...\r");

	    j=MDAC_SADDR/4L;
	    count=scan_len;
	    n=0L;

	    do
	      {
                TM_set_sptr(j*dat_type,&D);
		w_len=(T31_SBUSW_LEN/dat_type)-j%(T31_SBUSW_LEN/dat_type);
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++)
		  {
		    if(fill_mode==FILL_SINE)
		      {
                           *D++ = (long) ((double) (2000.0 * sin(2000.0*M_PI*((double)(n1+n))/((double) scan_len))));
		      }
		     else
			  *D++ = 0L;
		  }

                if(SBUS_err())
	           {
		     CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;
		j+=q;
		n+=q;
	      }
	     while (count>0);

     CLEAR_CURRENT_LINE;
		 LOAD_MAP(pmap_old);
		 return(0);
  }



 int __read_sb_data(long sb_addr, long len, void *pc_ptr)
  {
    long *LPTR,j, count,n1,q, w_len;


            LPTR=(long *)pc_ptr;
	    j=sb_addr;
	    count=len;

	    do
	      {

                TM_set_sptr(j*dat_type,&D);
		w_len=(T31_SBUSW_LEN/dat_type)-j%(T31_SBUSW_LEN/dat_type);
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++, *LPTR++= *D++);

                if(SBUS_err())
	           {
		      CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;
		j+=q;
	      }
	     while (count>0);
       return(0);

  }


 int __write_sb_data(long sb_addr, long len, void *pc_ptr)
  {
    long *LPTR,j, count,n1,q, w_len;


            LPTR=(long *)pc_ptr;
	    j=sb_addr;
	    count=len;

	    do
	      {

                TM_set_sptr(j*dat_type,&D);
		w_len=(T31_SBUSW_LEN/dat_type)-j%(T31_SBUSW_LEN/dat_type);
                if(count>=w_len) q=w_len;
		    else	q=count;

                for(n1=0;n1<q;n1++, *D++=*LPTR++ );

                if(SBUS_err())
	           {
		      CLEAR_CURRENT_LINE;
                     printf("error: SB error\n\n");
           	     return(1);
	           }
		count-=q;
		j+=q;
	      }
	     while (count>0);
       return(0);

  }






#define TMP_BUF_LEN	0x8000L


 int __move_adc_to_dac(long buf_len)
  {
	long count, j, q, *TMP, jd;
	unsigned pmap_old;



	pmap_old= READ_MAP();




	CLEAR_CURRENT_LINE;
	printf("moving SRAM data ...\r");


    if((TMP=(long *) halloc(TMP_BUF_LEN*4L,1))==NULL)

       { printf("error: out of memory\n\n");
	 return(1);
       }

                      /* copy ADC data to DAC buffer */

	    j=MADC_SADDR/4L;
	    jd=MDAC_SADDR/4L;
	    count=buf_len;

	    do
	      {
                if(count>=TMP_BUF_LEN) q=TMP_BUF_LEN;
		    else	q=count;
		if(   __read_sb_data(j,q,TMP)!=0
		   || __write_sb_data(jd,q,TMP)!=0
		  )
           	   {
                     hfree(TMP);return(1);
	           }
		count-=q;
		j+=q;
		jd+=q;
	      }
	     while (count>0);


	CLEAR_CURRENT_LINE;
	hfree(TMP);
	LOAD_MAP(pmap_old);

    return(0);
  }



int do_cmd(int adc_scan_enable, int wait_off_hook_only)
 {
  TM_set_sptr(MCD_SADDR,&MCD);

  MCD->cmnd		= cmnd;
  MCD->fq		= 0;
  MCD->epoch_len	= scan_len;
  MCD->status		= MSTAT_ATTN;
  MCD->chan		= 0;

  MCD_STLC = (struct MCD_STLC_DD*) (& ((char*)&(MCD->chan))[4]);

  MCD_STLC->is		= is;
  MCD_STLC->ra		= ra;
  MCD_STLC->rb		= rb;
  MCD_STLC->gain	= gain;


  adc_scan_flag=0;

  T31_SET_M_ATTN;  // set MASTER ATTN via interrupt

  printf("Waiting for OFF-HOOK... Press <SPACE> to terminate or <ESC> to abort...\r");

  do                      // wait for the SPACE/ESC pressed or OFF-HOOK
   {

     if(key_pressed())
       { switch (read_char())
	  { case KEY_ESC:
	         CLEAR_CURRENT_LINE;
	         printf("<execution aborted, T54x is reset>\n");
	         M_RESET;
		 T31_CLEAR_SBUS_ERR;
	         return(1);

            case 0x20:
   	            MCD->status=MSTAT_ABORT;
		    return(0);
		 break;

            default:
		 break;

	  }
       }

   }
    while(MCD_STLC->off_hook!=MLU_ON);


  if(wait_off_hook_only==MLU_ON)
     {
       CLEAR_CURRENT_LINE;
       goto exit;
     }


  CLEAR_CURRENT_LINE;
  if (adc_scan_enable==MLU_ON)
     printf("OFF-HOOK is detected. Press <SPACE> to start recording or <ESC> to abort...\r");
    else
     printf("OFF-HOOK is detected. Press <SPACE> to terminate output or <ESC> to abort...\r");


  do                      // wait for the ESC pressed or data ready
   {

     if(key_pressed())
       { switch (read_char())
	  { case KEY_ESC:
	         CLEAR_CURRENT_LINE;
	         printf("<execution aborted, T54x is reset>\n");
	         M_RESET;
		 T31_CLEAR_SBUS_ERR;
	         return(1);

            case 0x20:  // issue ADC SCAN synch
                 if (adc_scan_enable)
		  {
                    if (!adc_scan_flag)
	    	      { CLEAR_CURRENT_LINE;
		        printf("\rADC scanning...\r");
		        adc_scan_flag=MLU_ON;
		        MCD->status=MSTAT_GO;
		      }
		  }
		  else
   	          {
		    MCD->status=MSTAT_ABORT;
		    return(0);
		  }
		 break;

            default:
		 break;

	  }
       }

   }
    while(MCD->status!=MSTAT_RDY);

exit:
   if (MCD->err!=MLU_OK && MCD->err!=MERR_HOOK )
     { CLEAR_CURRENT_LINE;
       printf("error: %ld\n", MCD->err);
       return (1);
     }

   return(0);
 }


main()

{


   printf("\nDemo Utility for TORNADO-3x with T/SDAS-SLIC SIOX-module. v.1.0\n");
   printf("(C) MicroLAB Systems Ltd, 1997-1998\n\n");


   TM_set_sptr(MCD_SADDR,&MCD);
   T31_CLEAR_SBUS_ERR;

   M_RESET;       // init T3x and validate the response code
   M_BYTE_ACCESS;

      MCD->m_id=0xffffffff;
      MCD->prg_id=0xffffffff;
      MCD->status=0xffffffff;
      MCD->err=0xffffffff;
      MCD->adc_data_saddr=0xffffffff;
      MCD->dac_data_saddr=0xffffffff;

   MLU_set_bell(1,&TB);  // set time control =1s
   M_GO;

   while (MCD->status!=MSTAT_RDY) // wait for DSP will init or timeout
     {
       if(MLU_check_bell(&TB)<0)
	   { printf("error: no reply from TORNADO-3x\n\n");
	     goto exit;
	   }
       if(SBUS_err())
	   { printf("error: SB error\n\n");
	     goto exit;
	   }
     }


   if(MCD->m_id!=T31_M_ID       ||   // validate MCD returned
      MCD->prg_id!=T31_PRG_ID   ||
      MCD->status!=MSTAT_RDY    ||
      MCD->adc_data_saddr<0L    || MCD->adc_data_saddr>=T31_SRAM_LEN ||
      MCD->dac_data_saddr<0L    || MCD->dac_data_saddr>=T31_SRAM_LEN
     )
       { printf("error: invalid T3x initialization data\n");
	 goto exit;
       }

   MADC_SADDR = MCD->adc_data_saddr*4L;
   MDAC_SADDR = MCD->dac_data_saddr*4L;
   scan_len=SCAN_LEN_DEFAULT;
   __fill_dac_sram(FILL_ZERO);


while(1)
 {
   printf("\n commands : \n");
   printf("      0 : ring & wait OFF-HOOK; Output sine wave\n");
   printf("      1 : ring & wait OFF-HOOK; Record data in on-board SRAM\n");
   printf("      2 : ring & wait OFF-HOOK; Cyclic Playback data from on-board SRAM\n");
   printf("      3 : ring & wait OFF-HOOK. \n");
   printf("    Esc : exit to DOS\n\n");

   printf("enter command: ");

kbd_loop:
   switch(read_char())
     {
        case '0':
                CLEAR_CURRENT_LINE;
		printf("Ring & wait OFF-HOOK. Output sine wave >>>>\n");

		cmnd = MCMND_DAS_DAC_SCAN;
                if(inp_param()!=0) goto exit;
		scan_len=SCAN_LEN_DEFAULT;


		if (    __fill_dac_sram(FILL_SINE)!=0
		     || do_cmd(MLU_OFF, MLU_OFF)!=0
		     || __fill_dac_sram(FILL_ZERO)!=0
		   )
                    goto exit;
		break;


	case '1':

                CLEAR_CURRENT_LINE;
		printf("Ring & wait OFF-HOOK. Record data in on-board SRAM >>>>\n");
		cmnd = MCMND_DAS_DAC_SCAN;
                if(inp_param()!=0) goto exit;
		scan_len=SCAN_LEN_DEFAULT;


		if (    __fill_dac_sram(FILL_ZERO)!=0
                     || do_cmd(MLU_ON, MLU_OFF)!=0
		     || __move_adc_to_dac(scan_len)!=0
                   ) goto exit;
		break;




	case '2':
                CLEAR_CURRENT_LINE;
		printf("Ring & wait OFF-HOOK. Play data from on-board SRAM >>>>\n");

		cmnd = MCMND_DAS_DAC_SCAN;
                if(inp_param()!=0) goto exit;
		scan_len=SCAN_LEN_DEFAULT;

		if ( do_cmd(MLU_OFF, MLU_OFF)!=0) goto exit;

		break;


	case '3':
                CLEAR_CURRENT_LINE;
		printf("Ring & wait OFF-HOOK.  >>>>\n");
		cmnd = MCMND_OUT_RING ;
		gain = 2;
		is = 0;
		ra=24;rb=16;
		if ( do_cmd(MLU_OFF, MLU_ON)!=0) goto exit;
                break;


        case KEY_ESC:
	  printf(" <aborted>\n");
	  goto exit;

	default:
		beep_err();
		goto kbd_loop;
     }

        if ( MCD->err==MERR_HOOK )
	  {
                CLEAR_CURRENT_LINE;
	    printf("        <<<<<<<<<<<<<<      ON-HOOK      >>>>>>>>>>>>>> \n");
	  }

 }
exit:
   M_RESET;
   T31_CLEAR_SBUS_ERR;
  printf("\n");
}

